﻿//////////////////////////////////////////////
// EnvironmentManager.h
//
//////////////////////////////////////////////

/// Defines / Macros -------------------------

#pragma once

/// Forward decl -----------------------------

namespace nkScripts
{
	class Environment ;
}

/// Includes ---------------------------------

// nkScripts
#include "../Dll/DllDefines.h"

// nkCommon
#include <nilkinsCommon/Patterns/SingletonClass.h>

// nkMemory
#include <NilkinsMemory/Containers/StringView.h>

// Standards
#include <string>
#include <unordered_map>

/// Class ------------------------------------

namespace nkScripts
{
	class DLL_SCRIPTS_EXPORT EnvironmentManager final : public nkCommon::SingletonClass<EnvironmentManager>
	{
		friend class nkCommon::SingletonClass<EnvironmentManager> ;

		private :

			// Attributes
			// Map des environnements existants
			std::unordered_map<std::string, Environment*> _envMap ;

		private :

			// Functions
			// Constructeur, destructeur
			EnvironmentManager () ;
			~EnvironmentManager () ;

		public :

			// Demandes liées à la map
			Environment* createOrRetrieve (const nkMemory::StringView& name) ;
	} ;
}

